//This code is generated from a ModelicaML model.

within TwoTanksExample.Design.Components;

model Tank  
	TwoTanksExample.Design.Interfaces.ReadSignalOut tSensor;
	TwoTanksExample.Design.Interfaces.ActSignalIn tActuator;
	TwoTanksExample.Design.Interfaces.LiquidFlowIn qIn;
	TwoTanksExample.Design.Interfaces.LiquidFlowOut qOut;
	parameter Real flowGain= 0.05;
	parameter Real minV= 0;
	parameter Real maxV= 10;
	parameter Real area= 1;
	parameter Real height= 2;
	Real volume= area * height;
	Real levelOfLiquid;
	record Tank_StateMachine_sm__Tank_States
	annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, lineColor = {72,126,153}, fillColor = {219,241,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-75.0,-50.0},{75.0,50.0}}, radius = 30),Ellipse(visible = true, lineColor = {255,255,255}, fillColor = {72,126,153}, fillPattern = FillPattern.Solid, extent = {{44.3385,-21.3871},{92.5663,21.3871}})}));
		// lib properties STATE MACHINE
			Boolean active; // indicates if the state is active.
			Real timeAtActivation; // time when the state is entered.
			Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
			Boolean selfTransitionActivated;
		Boolean startBehaviour;
		// REGIONS instantiation
		sm__Tank_States_Region0 Region0;

		// REGIONS classes
		record sm__Tank_States_Region0
			annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, lineColor = {0,85,127}, fillColor = {224,242,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-78.5153,-50.0},{78.5153,50.0}}, radius = 30),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.0095,-8.4441},{2.0095,8.4441}}),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.3071,-45.0512},{1.7119,-28.163}}),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.0095,26.6749},{2.0095,43.5631}}),Rectangle(visible = true, lineColor = {0,85,127}, fillColor = {255,255,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-50.5952,50.119},{-0.5952,70.119}})}));
			// SIMPLE STATES instantiation
			SimpleState Empty;
			SimpleState Partially_filled;
			SimpleState Overflow;
			InitialState Initial0;
			
			/* M@ debug variables */
			Integer numberOfActiveStates;
			
		end sm__Tank_States_Region0;
		
		// library: SIMPLE STATE
		record SimpleState
			annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, origin = {-3.7995,0.2778}, lineColor = {104,182,221}, fillColor = {224,242,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-86.2005,-50.2778},{93.6579,59.7222}}, radius = 40),Text(visible = true, origin = {-3.6,0.8786}, lineColor = {0,0,255}, fillPattern = FillPattern.Solid, extent = {{-62.88,-35.04},{70.08,41.7601}}, textString = "SM", fontName = "Arial")}));
			// lib properties SIMPLE STATE
				Boolean active; // indicates if the state is active.
				Real timeAtActivation; // time when the state is entered.
				Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
				Boolean selfTransitionActivated;
		end SimpleState;
			
			// library: INITIAL STATE
		record InitialState
			annotation(Diagram(coordinateSystem(extent={{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10})), Icon(coordinateSystem(extent={{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10}), graphics={Rectangle(visible=true, origin={-0.0,0.0}, lineColor={0,85,127}, fillColor={104,182,221}, fillPattern=FillPattern.HorizontalCylinder, lineThickness=10, extent={{-34.8134,-34.6638},{34.8134,34.6638}}, radius=40)}));
			// lib properties INITIAL STATE
				Boolean active; // indicates if the state is active.
				Real timeAtActivation; // time when the state is entered.
				Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
				Boolean selfTransitionActivated;
		end InitialState;	
		
				// library: FINAL STATE
		record FinalState
			annotation(Diagram(coordinateSystem(extent={{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10})), Icon(coordinateSystem(extent={{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10}), graphics={Rectangle(visible=true, origin={0.0,0.0}, lineColor={0,85,127}, fillColor={255,255,255}, fillPattern=FillPattern.HorizontalCylinder, lineThickness=10, extent={{-34.8134,-34.6638},{34.8134,34.6638}}, radius=40),Rectangle(visible=true, origin={0.0,0.0}, fillPattern=FillPattern.HorizontalCylinder, lineThickness=10, extent={{-17.2767,-17.2024},{17.2767,17.2024}}, radius=40)}));
			// lib properties FINAL STATE
				Boolean active; // indicates if the state is active.
				Real timeAtActivation; // time when the state is entered.
				Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
				Boolean selfTransitionActivated;
		end FinalState;	
	end Tank_StateMachine_sm__Tank_States;



	// STATE MACHNE instantiation 
		Tank_StateMachine_sm__Tank_States sm__Tank_States;
	equation
		der(levelOfLiquid) = (qIn.lflow - qOut.lflow)/area;  // Mass balance equation
		
		qOut.lflow = TwoTanksExample.Design.Library.limitValue(minV, maxV, -flowGain*tActuator.act);
		
		tSensor.val = levelOfLiquid;
	algorithm
	algorithm

	/*** start behaviour code of state machine "sm__Tank_States" ***/
	algorithm

		
		
		

		/* initial state machine "sm__Tank_States" activation */
		sm__Tank_States.startBehaviour:=true; 
		when sm__Tank_States.startBehaviour then
		sm__Tank_States.active:=true; 
			sm__Tank_States.Region0.Initial0.active:=true;
		end when;	
		when {sm__Tank_States.active, sm__Tank_States.selfTransitionActivated} then
				sm__Tank_States.timeAtActivation := time;
				sm__Tank_States.selfTransitionActivated := false;
			end when;
			if sm__Tank_States.active then 
				sm__Tank_States.stime := time - sm__Tank_States.timeAtActivation;
			end if;
			if not sm__Tank_States.active then
				sm__Tank_States.stime := 0;
			end if;
		/*** start behaviour code of region "sm__Tank_States" ***/
	when {sm__Tank_States.Region0.Initial0.active, sm__Tank_States.Region0.Initial0.selfTransitionActivated} then
			sm__Tank_States.Region0.Initial0.timeAtActivation := time;
			sm__Tank_States.Region0.Initial0.selfTransitionActivated := false;
		end when;
		if sm__Tank_States.Region0.Initial0.active then 
			sm__Tank_States.Region0.Initial0.stime := time - sm__Tank_States.Region0.Initial0.timeAtActivation;
		end if;
		if not sm__Tank_States.Region0.Initial0.active then
			sm__Tank_States.Region0.Initial0.stime := 0;
		end if;
	when {sm__Tank_States.Region0.Empty.active, sm__Tank_States.Region0.Empty.selfTransitionActivated} then
			sm__Tank_States.Region0.Empty.timeAtActivation := time;
			sm__Tank_States.Region0.Empty.selfTransitionActivated := false;
		end when;
	when {sm__Tank_States.Region0.Partially_filled.active, sm__Tank_States.Region0.Partially_filled.selfTransitionActivated} then
			sm__Tank_States.Region0.Partially_filled.timeAtActivation := time;
			sm__Tank_States.Region0.Partially_filled.selfTransitionActivated := false;
		end when;
	when {sm__Tank_States.Region0.Overflow.active, sm__Tank_States.Region0.Overflow.selfTransitionActivated} then
			sm__Tank_States.Region0.Overflow.timeAtActivation := time;
			sm__Tank_States.Region0.Overflow.selfTransitionActivated := false;
		end when;
		if sm__Tank_States.Region0.Empty.active then 
			sm__Tank_States.Region0.Empty.stime := time - sm__Tank_States.Region0.Empty.timeAtActivation;
		end if;
		if not sm__Tank_States.Region0.Empty.active then
			sm__Tank_States.Region0.Empty.stime := 0;
		end if;
		if sm__Tank_States.Region0.Partially_filled.active then 
			sm__Tank_States.Region0.Partially_filled.stime := time - sm__Tank_States.Region0.Partially_filled.timeAtActivation;
		end if;
		if not sm__Tank_States.Region0.Partially_filled.active then
			sm__Tank_States.Region0.Partially_filled.stime := 0;
		end if;
		if sm__Tank_States.Region0.Overflow.active then 
			sm__Tank_States.Region0.Overflow.stime := time - sm__Tank_States.Region0.Overflow.timeAtActivation;
		end if;
		if not sm__Tank_States.Region0.Overflow.active then
			sm__Tank_States.Region0.Overflow.stime := 0;
		end if;

	/*start transition code*/

	if (sm__Tank_States.Region0.Initial0.active) then	
		sm__Tank_States.Region0.Initial0.active := false;
		sm__Tank_States.Region0.Empty.active := true; 
		
	end if;	
	/*test the composite state is still active*/
	if(sm__Tank_States.active  ) then 
		 if pre(sm__Tank_States.Region0.Empty.active) then
			if     levelOfLiquid > 0.01 then
			sm__Tank_States.Region0.Empty.active := false;
				sm__Tank_States.Region0.Partially_filled.active := true;

			end if;
	elseif pre(sm__Tank_States.Region0.Partially_filled.active) then
			if     levelOfLiquid < 0.01 then
			sm__Tank_States.Region0.Partially_filled.active := false;
				sm__Tank_States.Region0.Empty.active := true;

				elseif				    levelOfLiquid > height then
			sm__Tank_States.Region0.Partially_filled.active := false;
				sm__Tank_States.Region0.Overflow.active := true;
				
			end if;
	elseif pre(sm__Tank_States.Region0.Overflow.active) then
			if     levelOfLiquid < height then
			sm__Tank_States.Region0.Overflow.active := false;
				sm__Tank_States.Region0.Partially_filled.active := true;

			end if;
	end if;
	 end if; 
	/*end transition code*/
	/*start do Code*/



	/*end do Code*/



	/*** end behaviour code of region "Region0" ***/

		/*start terminate code for state machine "sm__Tank_States"*/
		if (not sm__Tank_States.active) then
		/* M@ start terminate code of region "sm__Tank_States" ***/
		sm__Tank_States.Region0.Initial0.active := false;
		sm__Tank_States.Region0.Empty.active := false; 
		sm__Tank_States.Region0.Partially_filled.active := false; 
		sm__Tank_States.Region0.Overflow.active := false; 
		/* M@ end terminate code of region "Region0" ***/
		end if;
		/*end terminate code for state machine "sm__Tank_States"*/
	/*** end behaviour code of state machine "sm__Tank_States" ***/	
	/* M@ reset debug variabels */
	sm__Tank_States.Region0.numberOfActiveStates := 0; 

	/* M@ start debug code of region "----sm__Tank_States" ***/
	if sm__Tank_States.Region0.Empty.active then 
		sm__Tank_States.Region0.numberOfActiveStates := sm__Tank_States.Region0.numberOfActiveStates + 1; 
	end if;
	if sm__Tank_States.Region0.Partially_filled.active then 
		sm__Tank_States.Region0.numberOfActiveStates := sm__Tank_States.Region0.numberOfActiveStates + 1; 
	end if;
	if sm__Tank_States.Region0.Overflow.active then 
		sm__Tank_States.Region0.numberOfActiveStates := sm__Tank_States.Region0.numberOfActiveStates + 1; 
	end if;
	if sm__Tank_States.Region0.Initial0.active then 
		sm__Tank_States.Region0.numberOfActiveStates := sm__Tank_States.Region0.numberOfActiveStates + 1; 
	end if;

	/* M@ validation code start*/

	if sm__Tank_States.active then 
		assert(not (sm__Tank_States.Region0.numberOfActiveStates < 1), "sm__Tank_States.Region0 has no active states although the parent state is active!");
		assert(not (sm__Tank_States.Region0.numberOfActiveStates > 1), "sm__Tank_States.Region0 has multiple active states which are mutually exclusive!");
	end if;

	if not sm__Tank_States.active then
		assert(sm__Tank_States.Region0.numberOfActiveStates == 0, "sm__Tank_States.Region0 has active states although the parent state is not active!");
	end if;

	/* M@ validation code start*/



	/* M@ end debug code of region "Region0" ***/
end Tank;

