//This code is generated from a ModelicaML model.

within TwoTanksExample.Requirements;

model Settling_time_and_bounds_after_a_change_of_input_flow "After each change of the tank input flow, the controller shall, within 20 sec., ensure that the level of liquid in tank is equal to the reference level with a tolerance of +/- 0.05 m. " 
	input Boolean inputLevelChanged;
	input Real levelInTank;
	input Real refLevel;
	constant Real timeOut= 20;
	constant Real tolerance= 0.05;
	output Integer status;
	record Settling_time_and_bounds_after_a_change_of_input_flow_StateMachine_Violation_Monitor
	annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, lineColor = {72,126,153}, fillColor = {219,241,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-75.0,-50.0},{75.0,50.0}}, radius = 30),Ellipse(visible = true, lineColor = {255,255,255}, fillColor = {72,126,153}, fillPattern = FillPattern.Solid, extent = {{44.3385,-21.3871},{92.5663,21.3871}})}));
		// lib properties STATE MACHINE
			Boolean active; // indicates if the state is active.
			Real timeAtActivation; // time when the state is entered.
			Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
			Boolean selfTransitionActivated;
		Boolean startBehaviour;
		// REGIONS instantiation
		Violation_Monitor_Region0 Region0;

		// REGIONS classes
		record Violation_Monitor_Region0
			annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, lineColor = {0,85,127}, fillColor = {224,242,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-78.5153,-50.0},{78.5153,50.0}}, radius = 30),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.0095,-8.4441},{2.0095,8.4441}}),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.3071,-45.0512},{1.7119,-28.163}}),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.0095,26.6749},{2.0095,43.5631}}),Rectangle(visible = true, lineColor = {0,85,127}, fillColor = {255,255,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-50.5952,50.119},{-0.5952,70.119}})}));
			// SIMPLE STATES instantiation
			SimpleState Waiting_for_input_flow_to_change;
			SimpleState Violated;
			InitialState Initial0;
			// COMPOSITE STATES instantiation
			Region0_Observing Observing;
			// COMPOSITE STATES classes
			record Region0_Observing
				annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, origin = {-3.7995,0.2778}, lineColor = {104,182,221}, fillColor = {224,242,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-86.2005,-50.2778},{93.6579,59.7222}}, radius = 40),Text(visible = true, origin = {-3.6,0.8786}, lineColor = {0,0,255}, fillPattern = FillPattern.Solid, extent = {{-62.88,-35.04},{70.08,41.7601}}, textString = "SM", fontName = "Arial")}));
				// lib properties COMPOSITE STATE
					Boolean active; // indicates if the state is active.
					Real timeAtActivation; // time when the state is entered.
					Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
					Boolean selfTransitionActivated;
				// REGIONS instantiation
				Observing_Region0 Region0;
				record Observing_Region0
			annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, lineColor = {0,85,127}, fillColor = {224,242,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-78.5153,-50.0},{78.5153,50.0}}, radius = 30),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.0095,-8.4441},{2.0095,8.4441}}),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.3071,-45.0512},{1.7119,-28.163}}),Rectangle(visible = true, lineColor = {128,128,128}, fillColor = {128,128,128}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-2.0095,26.6749},{2.0095,43.5631}}),Rectangle(visible = true, lineColor = {0,85,127}, fillColor = {255,255,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-50.5952,50.119},{-0.5952,70.119}})}));
			// SIMPLE STATES instantiation
			SimpleState Waiting;
			SimpleState Evaluated__not_violated;
			InitialState Initial0;
			
			/* M@ debug variables */
			Integer numberOfActiveStates;
			
		end Observing_Region0;
			end Region0_Observing;
			
			/* M@ debug variables */
			Integer numberOfActiveStates;
			
		end Violation_Monitor_Region0;
		
		// library: SIMPLE STATE
		record SimpleState
			annotation(Diagram(coordinateSystem(extent = {{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10})), Icon(coordinateSystem(extent = {{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio = true, initialScale = 0.1, grid = {10,10}), graphics = {Rectangle(visible = true, origin = {-3.7995,0.2778}, lineColor = {104,182,221}, fillColor = {224,242,255}, fillPattern = FillPattern.Solid, lineThickness = 1, extent = {{-86.2005,-50.2778},{93.6579,59.7222}}, radius = 40),Text(visible = true, origin = {-3.6,0.8786}, lineColor = {0,0,255}, fillPattern = FillPattern.Solid, extent = {{-62.88,-35.04},{70.08,41.7601}}, textString = "SM", fontName = "Arial")}));
			// lib properties SIMPLE STATE
				Boolean active; // indicates if the state is active.
				Real timeAtActivation; // time when the state is entered.
				Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
				Boolean selfTransitionActivated;
		end SimpleState;
			
			// library: INITIAL STATE
		record InitialState
			annotation(Diagram(coordinateSystem(extent={{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10})), Icon(coordinateSystem(extent={{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10}), graphics={Rectangle(visible=true, origin={-0.0,0.0}, lineColor={0,85,127}, fillColor={104,182,221}, fillPattern=FillPattern.HorizontalCylinder, lineThickness=10, extent={{-34.8134,-34.6638},{34.8134,34.6638}}, radius=40)}));
			// lib properties INITIAL STATE
				Boolean active; // indicates if the state is active.
				Real timeAtActivation; // time when the state is entered.
				Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
				Boolean selfTransitionActivated;
		end InitialState;	
		
				// library: FINAL STATE
		record FinalState
			annotation(Diagram(coordinateSystem(extent={{-148.5,-105.0},{148.5,105.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10})), Icon(coordinateSystem(extent={{-100.0,-100.0},{100.0,100.0}}, preserveAspectRatio=true, initialScale=0.1, grid={10,10}), graphics={Rectangle(visible=true, origin={0.0,0.0}, lineColor={0,85,127}, fillColor={255,255,255}, fillPattern=FillPattern.HorizontalCylinder, lineThickness=10, extent={{-34.8134,-34.6638},{34.8134,34.6638}}, radius=40),Rectangle(visible=true, origin={0.0,0.0}, fillPattern=FillPattern.HorizontalCylinder, lineThickness=10, extent={{-17.2767,-17.2024},{17.2767,17.2024}}, radius=40)}));
			// lib properties FINAL STATE
				Boolean active; // indicates if the state is active.
				Real timeAtActivation; // time when the state is entered.
				Real stime; // stime means "state time". It is is a local timer. It starts when the state is entered and is equal to zero if the state is not active.
				Boolean selfTransitionActivated;
		end FinalState;	
	end Settling_time_and_bounds_after_a_change_of_input_flow_StateMachine_Violation_Monitor;



	// STATE MACHNE instantiation 
		Settling_time_and_bounds_after_a_change_of_input_flow_StateMachine_Violation_Monitor Violation_Monitor;
		
		/* M@ start composite Observing */

		/* M@ end composite Observing */
	algorithm
	algorithm

	/*** start behaviour code of state machine "Violation_Monitor" ***/
	algorithm

		
		
		/* M@ start composite Observing */

		/* M@ end composite Observing */

		/* initial state machine "Violation_Monitor" activation */
		Violation_Monitor.startBehaviour:=true; 
		when Violation_Monitor.startBehaviour then
		Violation_Monitor.active:=true; 
			Violation_Monitor.Region0.Initial0.active:=true;
		end when;	
		when {Violation_Monitor.active, Violation_Monitor.selfTransitionActivated} then
				Violation_Monitor.timeAtActivation := time;
				Violation_Monitor.selfTransitionActivated := false;
			end when;
			if Violation_Monitor.active then 
				Violation_Monitor.stime := time - Violation_Monitor.timeAtActivation;
			end if;
			if not Violation_Monitor.active then
				Violation_Monitor.stime := 0;
			end if;
		/*** start behaviour code of region "Violation_Monitor" ***/
	when {Violation_Monitor.Region0.Initial0.active, Violation_Monitor.Region0.Initial0.selfTransitionActivated} then
			Violation_Monitor.Region0.Initial0.timeAtActivation := time;
			Violation_Monitor.Region0.Initial0.selfTransitionActivated := false;
		end when;
		if Violation_Monitor.Region0.Initial0.active then 
			Violation_Monitor.Region0.Initial0.stime := time - Violation_Monitor.Region0.Initial0.timeAtActivation;
		end if;
		if not Violation_Monitor.Region0.Initial0.active then
			Violation_Monitor.Region0.Initial0.stime := 0;
		end if;
	when {Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active, Violation_Monitor.Region0.Waiting_for_input_flow_to_change.selfTransitionActivated} then
			Violation_Monitor.Region0.Waiting_for_input_flow_to_change.timeAtActivation := time;
			Violation_Monitor.Region0.Waiting_for_input_flow_to_change.selfTransitionActivated := false;
		end when;
	when {Violation_Monitor.Region0.Observing.active, Violation_Monitor.Region0.Observing.selfTransitionActivated} then
			Violation_Monitor.Region0.Observing.timeAtActivation := time;
			Violation_Monitor.Region0.Observing.selfTransitionActivated := false;
		end when;
	when {Violation_Monitor.Region0.Violated.active, Violation_Monitor.Region0.Violated.selfTransitionActivated} then
			Violation_Monitor.Region0.Violated.timeAtActivation := time;
			Violation_Monitor.Region0.Violated.selfTransitionActivated := false;
		end when;
		if Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active then 
			Violation_Monitor.Region0.Waiting_for_input_flow_to_change.stime := time - Violation_Monitor.Region0.Waiting_for_input_flow_to_change.timeAtActivation;
		end if;
		if not Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active then
			Violation_Monitor.Region0.Waiting_for_input_flow_to_change.stime := 0;
		end if;
		if Violation_Monitor.Region0.Observing.active then 
			Violation_Monitor.Region0.Observing.stime := time - Violation_Monitor.Region0.Observing.timeAtActivation;
		end if;
		if not Violation_Monitor.Region0.Observing.active then
			Violation_Monitor.Region0.Observing.stime := 0;
		end if;
		if Violation_Monitor.Region0.Violated.active then 
			Violation_Monitor.Region0.Violated.stime := time - Violation_Monitor.Region0.Violated.timeAtActivation;
		end if;
		if not Violation_Monitor.Region0.Violated.active then
			Violation_Monitor.Region0.Violated.stime := 0;
		end if;

	/*start transition code*/

	if (Violation_Monitor.Region0.Initial0.active) then	
		Violation_Monitor.Region0.Initial0.active := false;
		Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active := true; 
		
	end if;	
	/*test the composite state is still active*/
	if(Violation_Monitor.active  ) then 
		 if pre(Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active) then
			if     inputLevelChanged then
			Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active := false;
				Violation_Monitor.Region0.Observing.active := true; 
			Violation_Monitor.Region0.Observing.Region0.Initial0.active := true;

			end if;
	elseif pre(Violation_Monitor.Region0.Observing.active) then
			if     inputLevelChanged then
			/*start composite highlevel transition deactivate active substate*/
			if (Violation_Monitor.Region0.Observing.Region0.Waiting.active) then
				Violation_Monitor.Region0.Observing.Region0.Waiting.active:=false;
			end if;
			if (Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active) then
				Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active:=false;
			end if;
			/*end composite highlevel transition deactivate active substate*/
			Violation_Monitor.Region0.Observing.active := false;
				Violation_Monitor.Region0.Observing.active := true; 
				Violation_Monitor.Region0.Observing.selfTransitionActivated := true;
			Violation_Monitor.Region0.Observing.Region0.Initial0.active := true;

				elseif				    (Violation_Monitor.Region0.Observing.stime > (timeOut)  and   (levelInTank < (refLevel - tolerance) or levelInTank > (refLevel + tolerance))) then
			/*start composite highlevel transition deactivate active substate*/
			if (Violation_Monitor.Region0.Observing.Region0.Waiting.active) then
				Violation_Monitor.Region0.Observing.Region0.Waiting.active:=false;
			end if;
			if (Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active) then
				Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active:=false;
			end if;
			/*end composite highlevel transition deactivate active substate*/
			Violation_Monitor.Region0.Observing.active := false;
				Violation_Monitor.Region0.Violated.active := true; 
				//state "Violation_Monitor.Region0.Violated": entry behavior
				status := 2;
				
			end if;
	elseif pre(Violation_Monitor.Region0.Violated.active) then
			if     inputLevelChanged then
			Violation_Monitor.Region0.Violated.active := false;
				Violation_Monitor.Region0.Observing.active := true; 
			Violation_Monitor.Region0.Observing.Region0.Initial0.active := true;

			end if;
	end if;
	 end if; 
	/*end transition code*/
	/*start do Code*/



	/*end do Code*/


	/*start composite Observing */
			/*** start behaviour code of region "Violation_Monitor.Region0.Observing" ***/
		when {Violation_Monitor.Region0.Observing.Region0.Initial0.active, Violation_Monitor.Region0.Observing.Region0.Initial0.selfTransitionActivated} then
				Violation_Monitor.Region0.Observing.Region0.Initial0.timeAtActivation := time;
				Violation_Monitor.Region0.Observing.Region0.Initial0.selfTransitionActivated := false;
			end when;
			if Violation_Monitor.Region0.Observing.Region0.Initial0.active then 
				Violation_Monitor.Region0.Observing.Region0.Initial0.stime := time - Violation_Monitor.Region0.Observing.Region0.Initial0.timeAtActivation;
			end if;
			if not Violation_Monitor.Region0.Observing.Region0.Initial0.active then
				Violation_Monitor.Region0.Observing.Region0.Initial0.stime := 0;
			end if;
		when {Violation_Monitor.Region0.Observing.Region0.Waiting.active, Violation_Monitor.Region0.Observing.Region0.Waiting.selfTransitionActivated} then
				Violation_Monitor.Region0.Observing.Region0.Waiting.timeAtActivation := time;
				Violation_Monitor.Region0.Observing.Region0.Waiting.selfTransitionActivated := false;
			end when;
		when {Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active, Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.selfTransitionActivated} then
				Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.timeAtActivation := time;
				Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.selfTransitionActivated := false;
			end when;
			if Violation_Monitor.Region0.Observing.Region0.Waiting.active then 
				Violation_Monitor.Region0.Observing.Region0.Waiting.stime := time - Violation_Monitor.Region0.Observing.Region0.Waiting.timeAtActivation;
			end if;
			if not Violation_Monitor.Region0.Observing.Region0.Waiting.active then
				Violation_Monitor.Region0.Observing.Region0.Waiting.stime := 0;
			end if;
			if Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active then 
				Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.stime := time - Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.timeAtActivation;
			end if;
			if not Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active then
				Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.stime := 0;
			end if;

		/*start transition code*/

		if (Violation_Monitor.Region0.Observing.Region0.Initial0.active) then	
			Violation_Monitor.Region0.Observing.Region0.Initial0.active := false;
			Violation_Monitor.Region0.Observing.Region0.Waiting.active := true; 
			
		end if;	
		/*test the composite state is still active*/
		if(Violation_Monitor.Region0.Observing.active  ) then 
			 if pre(Violation_Monitor.Region0.Observing.Region0.Waiting.active) then
				if     (Violation_Monitor.Region0.Observing.Region0.Waiting.stime > (timeOut)) then
				Violation_Monitor.Region0.Observing.Region0.Waiting.active := false;
					Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active := true; 
					//state "Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated": entry behavior
					status := 1;

				end if;
		end if;
		 end if; 
		/*end transition code*/
		/*start do Code*/


		/*end do Code*/



		/*** end behaviour code of region "Region0" ***/
	/*end composite Observing */

	/*** end behaviour code of region "Region0" ***/

		/*start terminate code for state machine "Violation_Monitor"*/
		if (not Violation_Monitor.active) then
		/* M@ start terminate code of region "Violation_Monitor" ***/
		Violation_Monitor.Region0.Initial0.active := false;
		Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active := false; 
		Violation_Monitor.Region0.Observing.active := false; 
		Violation_Monitor.Region0.Violated.active := false; 
		/* M@ start composite Observing */
		/* M@ start terminate code of region "Violation_Monitor.Region0.Observing" ***/
		Violation_Monitor.Region0.Observing.Region0.Initial0.active := false;
		Violation_Monitor.Region0.Observing.Region0.Waiting.active := false; 
		Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active := false; 
		/* M@ end terminate code of region "Region0" ***/
		/* M@ end composite Observing */
		/* M@ end terminate code of region "Region0" ***/
		end if;
		/*end terminate code for state machine "Violation_Monitor"*/
	/*** end behaviour code of state machine "Violation_Monitor" ***/	
	/* M@ reset debug variabels */
	Violation_Monitor.Region0.numberOfActiveStates := 0; 

	/* M@ start debug code of region "----Violation_Monitor" ***/
	if Violation_Monitor.Region0.Waiting_for_input_flow_to_change.active then 
		Violation_Monitor.Region0.numberOfActiveStates := Violation_Monitor.Region0.numberOfActiveStates + 1; 
	end if;
	if Violation_Monitor.Region0.Observing.active then 
		Violation_Monitor.Region0.numberOfActiveStates := Violation_Monitor.Region0.numberOfActiveStates + 1; 
	end if;
	if Violation_Monitor.Region0.Violated.active then 
		Violation_Monitor.Region0.numberOfActiveStates := Violation_Monitor.Region0.numberOfActiveStates + 1; 
	end if;
	if Violation_Monitor.Region0.Initial0.active then 
		Violation_Monitor.Region0.numberOfActiveStates := Violation_Monitor.Region0.numberOfActiveStates + 1; 
	end if;

	/* M@ validation code start*/

	if Violation_Monitor.active then 
		assert(not (Violation_Monitor.Region0.numberOfActiveStates < 1), "Violation_Monitor.Region0 has no active states although the parent state is active!");
		assert(not (Violation_Monitor.Region0.numberOfActiveStates > 1), "Violation_Monitor.Region0 has multiple active states which are mutually exclusive!");
	end if;

	if not Violation_Monitor.active then
		assert(Violation_Monitor.Region0.numberOfActiveStates == 0, "Violation_Monitor.Region0 has active states although the parent state is not active!");
	end if;

	/* M@ validation code start*/

	/* M@ start composite Observing */
			/* M@ reset debug variabels */
		Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates := 0; 

		/* M@ start debug code of region "----Violation_Monitor.Region0.Observing" ***/
		if Violation_Monitor.Region0.Observing.Region0.Waiting.active then 
			Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates := Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates + 1; 
		end if;
		if Violation_Monitor.Region0.Observing.Region0.Evaluated__not_violated.active then 
			Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates := Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates + 1; 
		end if;
		if Violation_Monitor.Region0.Observing.Region0.Initial0.active then 
			Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates := Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates + 1; 
		end if;

		/* M@ validation code start*/

		if Violation_Monitor.Region0.Observing.active then 
			assert(not (Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates < 1), "Violation_Monitor.Region0.Observing.Region0 has no active states although the parent state is active!");
			assert(not (Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates > 1), "Violation_Monitor.Region0.Observing.Region0 has multiple active states which are mutually exclusive!");
		end if;

		if not Violation_Monitor.Region0.Observing.active then
			assert(Violation_Monitor.Region0.Observing.Region0.numberOfActiveStates == 0, "Violation_Monitor.Region0.Observing.Region0 has active states although the parent state is not active!");
		end if;

		/* M@ validation code start*/



		/* M@ end debug code of region "Region0" ***/
	/* M@ end composite Observing */


	/* M@ end debug code of region "Region0" ***/
end Settling_time_and_bounds_after_a_change_of_input_flow;

